﻿601,100
562,"NULL"
586,
585,
564,
565,"di;qatzbl6Hp1CJ;qVw;v`\_6ewa7ma:nb2T:r3l>eXn5@FV9O`pxMnP\m9eBS?R^It8bH@M05`HozQbkRJb:hrD66Xh7z<Ww1neP[6Et?u^Iwy<^YlzJpLx0^?n>sCHo^:yC]0pm[8gT>mYgqXJlwYCiLJaR0j16vNHHcly2o_tJJJyY_59hb0xXb^G62SmtGZNj:Ak"
559,1
928,0
593,
594,
595,
597,
598,
596,
800,
801,
566,0
567,","
588,"."
589,
568,""""
570,
571,
569,0
592,0
599,1000
560,5
pGuid
pAppId
pOwnerGroup
pRemoveRights
pControl
561,5
2
2
2
2
2
590,5
pGuid,"None"
pAppId,"MyApp"
pOwnerGroup,"None"
pRemoveRights,"Y"
pControl,"N"
637,5
pGuid,
pAppId,
pOwnerGroup,
pRemoveRights,
pControl,
577,0
578,0
579,0
580,0
581,0
582,0
572,260


#################################################################
## IBM Confidential
##
## OCO Source Materials
##
## BI and PM: pmpsvc
##
## (C) Copyright IBM Corp. 2008, 2009
##
## The source code for this program is not published or otherwise
## divested of its trade secrets, irrespective of what has been
## deposited with the U.S. Copyright Office.
#################################################################


cControlPrefix = '';
If (pControl @= 'Y');
cControlPrefix = '}';
EndIf;

#*** Log File Name
cTM1Process = cControlPrefix | 'tp_clean_one_owner_group';
StringGlobalVariable('gPrologLog');
StringGlobalVariable('gEpilogLog');
vReturnValue = ExecuteProcess( cControlPrefix | 'tp_get_log_file_names', 
'pExecutionId', pGuid,
'pProcess', cTM1Process, 'pControl', pControl);
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;
cPrologLog = gPrologLog;
cEpilogLog = gEpilogLog;
cTM1Log = cPrologLog;

cGenerateLog = ATTRS(cControlPrefix | 'tp_config', 'Generate TI Log', 'String Value');

#*** Log Parameters
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Parameters:', pGuid, pAppID, pOwnerGroup, pControl);
EndIf;

#*** 

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Check application');
EndIf;

cApplicationsDim = cControlPrefix |  'tp_applications';

If (DimensionExists(cApplicationsDim) = 0);
ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube', 
'pGuid', pGuid, 
'pProcess', cTM1Process,
'pErrorCode', 'TI_DIM_NOT_EXIST',
'pErrorDetails', cApplicationsDim, 
'pControl', pControl);

ProcessError;
EndIf;

If (DIMIX(cApplicationsDim, pAppId) = 0);
ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube', 
'pGuid', pGuid, 
'pProcess', cTM1Process,
'pErrorCode', 'TI_NODE_NOT_EXIST',
'pErrorDetails', pAppId, 
'pControl', pControl);

ProcessError;
EndIf;

#*** 

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Get Approval dimension and subset');
EndIf;

StringGlobalVariable('gApprovalDim');
StringGlobalVariable('gApprovalSubset');

vReturnValue = ExecuteProcess( cControlPrefix | 'tp_get_application_attributes', 'pExecutionId', pGuid,
'pAppId', pAppId, 'pControl',  pControl);
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;

cApprovalDim = gApprovalDim;
cApprovalSubset = gApprovalSubset;

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Approval Dimension: ' | cApprovalDim);
TextOutput(cTM1Log, 'Approval Subset: ' | cApprovalSubset);
EndIf;


#*** 

cApprovalElementSecurityCube = '}ElementSecurity_' | gApprovalDim;

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 
'Check element security cube: ' | cApprovalElementSecurityCube);
EndIf;

If (CubeExists(cApprovalElementSecurityCube) = 0);
ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube', 
'pGuid', pGuid, 
'pProcess', cTM1Process,
'pErrorCode', 'TI_CUBE_NOT_EXIST', 
'pErrorDetails', cApprovalElementSecurityCube, 
'pControl', pControl);

ProcessError;
EndIf;

#*** 

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Check owner group: ' | pOwnerGroup);
EndIf;

If (DIMIX('}Groups', pOwnerGroup) = 0);
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube',
'pGuid', pGuid,
'pProcess', cTM1Process,
'pErrorCode', 'TI_NODE_NOT_EXIST',
'pErrorDetails', '}Groups' | ', ' | pOwnerGroup,
'pControl', pControl);

ProcessError;
EndIf;

cTpOwnerGroupPrefix = cControlPrefix | 'tp_owner_';
cTpOwnerGroupPrefixLength = LONG(cTpOwnerGroupPrefix);
If (cTpOwnerGroupPrefix @<> SUBST(pOwnerGroup, 1, cTpOwnerGroupPrefixLength));
ProcessError;
EndIf;

#*** Remove rights
If (pRemoveRights @= 'Y');

vMDX1 = '[' | cApprovalElementSecurityCube | '].[}Groups].[' | pOwnerGroup | '] = "Write"';
vMDX2 = 'FILTER([' | gApprovalDim | '].MEMBERS, ' | vMDX1 | ')';

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'MDX: ' | vMDX2);
EndIf;

cOwnedNodesSubset = 'tp_temp_owned_nodes_' | pGuid | pOwnerGroup;
SubsetDestroy(gApprovalDim, cOwnedNodesSubset);
SubsetCreateByMdx(cOwnedNodesSubset, vMDX2);
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'owned nodes subset size: ' | STR(SubsetGetSize(gApprovalDim, cOwnedNodesSubset), 5, 0));
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'first owned node: ' | SubsetGetElementName(gApprovalDim, cOwnedNodesSubset, 1));
EndIf;

cOwnedNodesSubsetSize = SubsetGetSize(gApprovalDim, cOwnedNodesSubset);
If (cOwnedNodesSubsetSize > 0);

vIndex = 1;
While (vIndex <= cOwnedNodesSubsetSize);
# Each operation will refresh the subset.
vElement = SubsetGetElementName(gApprovalDim, cOwnedNodesSubset, 1);
ElementSecurityPut('None', gApprovalDim, vElement, pOwnerGroup);
vIndex = vIndex + 1;
End;

EndIf;

SubsetDestroy(gApprovalDim, cOwnedNodesSubset);

EndIf;

#*** Check other applications

cApprovalDimensionAttr = 'ApprovalDimension';
cApprovalSubsetAttr = 'ApprovalSubset';

cApplicationsDimSize = DIMSIZ(cApplicationsDim);
vIndex = 1;
vIsOwnerGroupUsedByOther = 'N';
While (vIndex <= cApplicationsDimSize);

vElement = DIMNM(cApplicationsDim, vIndex);
If (vElement @<> pAppId);
vApprovalDim = ATTRS(cApplicationsDim, vElement, cApprovalDimensionAttr); 
vApprovalElementSecurityCube = '}ElementSecurity_' | vApprovalDim;

vFirstNode = DIMNM(vApprovalDim, 1);
If (CellGetS(vApprovalElementSecurityCube, vFirstNode, pOwnerGroup) @= 'Write');

vIsOwnerGroupUsedByOther = 'Y';
vIndex = cApplicationsDimSize;

Else;

vMDX1 = '[' | vApprovalElementSecurityCube | '].[}Groups].[' | pOwnerGroup | '] = "Write"';
vMDX2 = '{[' | vApprovalDim | '].[' | vFirstNode | '], FILTER([' | vApprovalDim | '].MEMBERS, ' | vMDX1 | ')}';

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'MDX: ' | vMDX2);
EndIf;

vOwnedNodesSubset = 'tp_owned_nodes_' | pGuid | pOwnerGroup;
SubsetDestroy(vApprovalDim, vOwnedNodesSubset);
SubsetCreateByMdx(vOwnedNodesSubset, vMDX2);
If (SubsetGetSize(vApprovalDim, vOwnedNodesSubset) > 1);
vIsOwnerGroupUsedByOther = 'Y';
vIndex = cApplicationsDimSize;
EndIf;

EndIf;

SubsetDestroy(vApprovalDim, vOwnedNodesSubset);

EndIf;

vIndex = vIndex + 1;
End;

#*** Empty owner group

If (vIsOwnerGroupUsedByOther @= 'N');

vMDX1 = '[}ClientGroups].[}Groups].[' | pOwnerGroup | '] <> ""';
vMDX2 = '{[}Clients].[admin], FILTER([}Clients].MEMBERS, ' | vMDX1 | ')}';

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'MDX: ' | vMDX2);
EndIf;

cClientsSubset = 'tp_clients_' | pGuid | pOwnerGroup;
SubsetDestroy('}Clients', cClientsSubset);
SubsetCreateByMdx(cClientsSubset, vMDX2);

cClientsSubsetSize = SubsetGetSize('}Clients', cClientsSubset);
vIndex = 1;
While (vIndex <= cClientsSubsetSize);
vElement = SubsetGetElementName('}Clients', cClientsSubset, vIndex);
If (vElement @<> 'admin');
RemoveClientFromGroup(vElement, pOwnerGroup);
EndIf;

vIndex = vIndex + 1;
End;

SubsetDestroy('}Clients', cClientsSubset);

EndIf;

#*** No error

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'The end has been reached.');
EndIf;



573,1

574,1

575,1

576,
638,1
804,0
1217,0
900,
901,
902,
903,
906,
907,
908,
904,0
905,0
909,0
911,
912,
913,
914,
915,
916,
917,1
918,1
919,0
920,50000
921,""
922,""
923,0
924,""
925,""
926,""
927,""
