﻿601,100
562,"NULL"
586,
585,
564,
565,"g::kn?:a[j>:aNJG[]Po[\gd>j88aE]B??b]oo>cl<8asqWfium`1dXOdOmNnue0VM?6xc9N`hV<gEs\P@1=dxTb[tK55rSO:Q:=\:z6orGWzRK]6`f96v9eOrxUa3y`8MF8T1FPQs2Py1>sPt4:xWd@3w8p:VXJMi[SrhwuT0GdGpaxNtMqY_9\Mj;hnvP=tNOiK>lS"
559,1
928,0
593,
594,
595,
597,
598,
596,
800,
801,
566,0
567,","
588,"."
589,
568,""""
570,
571,
569,0
592,0
599,1000
560,5
pGuid
pAppId
pPadSet
pTest
pControl
561,5
2
2
2
2
2
590,5
pGuid,"None"
pAppId,"MyApp"
pPadSet,"Y"
pTest,"N"
pControl,"N"
637,5
pGuid,
pAppId,
pPadSet,
pTest,
pControl,
577,0
578,0
579,0
580,0
581,0
582,0
572,158


#################################################################
## IBM Confidential
##
## OCO Source Materials
##
## BI and PM: pmpsvc
##
## (C) Copyright IBM Corp. 2008, 2009
##
## The source code for this program is not published or otherwise
## divested of its trade secrets, irrespective of what has been
## deposited with the U.S. Copyright Office.
#################################################################


cControlPrefix = '';
If (pControl @= 'Y');
cControlPrefix = '}';
EndIf;

#*** Log File Name
cTM1Process = cControlPrefix | 'tp_mdx_find_owner_groups';
StringGlobalVariable('gPrologLog');
StringGlobalVariable('gEpilogLog');
vReturnValue = ExecuteProcess( cControlPrefix | 'tp_get_log_file_names', 'pExecutionId', pGuid,
'pProcess', cTM1Process, 'pControl', pControl);
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;
cPrologLog = gPrologLog;
cEpilogLog = gEpilogLog;
cTM1Log = cPrologLog;

cGenerateLog = ATTRS(cControlPrefix | 'tp_config', 'Generate TI Log', 'String Value');

#*** Log Parameters
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Parameters:', pGuid, pAppID, pPadSet, pControl);
EndIf;

#*** 

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Check application');
EndIf;

cApplicationsDim = cControlPrefix |  'tp_applications';

If (DimensionExists(cApplicationsDim) = 0);
ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube', 
'pGuid', pGuid, 
'pProcess', cTM1Process,
'pErrorCode', 'TI_DIM_NOT_EXIST', 
'pErrorDetails', cApplicationsDim, 
'pControl', pControl);

ProcessError;
EndIf;

If (DIMIX(cApplicationsDim, pAppId) = 0);
ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube', 
'pGuid', pGuid, 
'pProcess', cTM1Process,
'pErrorCode', 'TI_NODE_NOT_EXIST',
'pErrorDetails', pAppId, 
'pControl', pControl);

ProcessError;
EndIf;

#*** 

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Get Approval dimension and subset');
EndIf;

StringGlobalVariable('gApprovalDim');
StringGlobalVariable('gApprovalSubset');

vReturnValue = ExecuteProcess( cControlPrefix | 'tp_get_application_attributes', 'pExecutionId', pGuid,
'pAppId', pAppId, 'pControl',  pControl);
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;

cApprovalDim = gApprovalDim;
cApprovalSubset = gApprovalSubset;

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Approval Dimension: ' | cApprovalDim);
TextOutput(cTM1Log, 'Approval Subset: ' | cApprovalSubset);
EndIf;

cApprovalSize = DIMSIZ(cApprovalDim);

cGroupDim = '}Groups';
cGroupDimSize = DIMSIZ(cGroupDim);

#*** Check cube

cApprovalElementSecurityCube = '}ElementSecurity_' | gApprovalDim;
If (CubeExists(cApprovalElementSecurityCube) = 0);
ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube', 
'pGuid', pGuid, 
'pProcess', cTM1Process,
'pErrorCode', 'TI_CUBE_NOT_EXIST', 
'pErrorDetails', cApprovalElementSecurityCube, 
'pControl', pControl);

ProcessError;
EndIf;

#*** declare global variables
StringGlobalVariable('gMdxFindOwnerGroups');

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Find application groups');
EndIf;
vMDX1 ='TM1FILTERBYPATTERN(TM1SUBSETALL([}Groups]), "*tp_owner*")';
vMDX2 = '[' | cApprovalElementSecurityCube | '].[}Groups].CURRENTMEMBER = "Write"';
vMDX3 = 'FILTER([' | gApprovalDim | '].MEMBERS, ' | vMDX2 | ')';
vMDX4 = 'FILTER(' | vMDX1 | ', COUNT(' | vMDX3 | ') > 0)';
If (pPadSet @= 'Y');
vMDX5 = '{' | vMdx4 | ', [}Groups].[admin]}';
gMdxFindOwnerGroups = vMdx5;
Else;
gMdxFindOwnerGroups = vMdx4;
EndIf;

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'MDX for owner groups', gMdxFindOwnerGroups);
EndIf;

#*** Test

If (pTest @= 'Y');

vTempSubset = 'tp_temp_subset' | pGuid;
SubsetDestroy('}Groups', vTempSubset);
SubsetCreateByMdx(vTempSubset, gMdxFindOwnerGroups);
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'owner groups subset size: ' | STR(SubsetGetSize('}Groups', vTempSubset), 5, 0));
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'first owner group: ' | SubsetGetElementName('}Groups', vTempSubset, 1));
EndIf;

SubsetDestroy('}Groups', vTempSubset);

EndIf;

#*** No error

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'The end has been reached.');
EndIf;


573,1

574,1

575,1

576,
638,1
804,0
1217,0
900,
901,
902,
903,
906,
907,
908,
904,0
905,0
909,0
911,
912,
913,
914,
915,
916,
917,1
918,1
919,0
920,50000
921,""
922,""
923,0
924,""
925,""
926,""
927,""
